/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief tps02r¶ȶȡ
 *
 * \par Դ
 * \snippet demo_zlg116_tps02r.c src_zlg116_tps02r
 *
 * \internal
 * \par Modification History
 * - 1.00 18-07-19  zcb, first implementation.
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg116_tps02r
 * \copydoc demo_zlg116_tps02r.c
 */

/** [src_zlg116_tps02r] */

#include "ametal.h"
#include "am_i2c.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zlg116_inst_init.h"

#define __REG_TEMPERATURE        0x00  /**< \brief ¶ȼĴַ */

#define __REG_TEMPERATURE_LEN    0x6   /**< \brief ¶ȼĴ */

/**
 * \brief ¶ת
 */
static float __reg_to_temperature (uint8_t *p_dat)
{
    uint32_t temp = 0;

    temp |= p_dat[0] << 16;
    temp |= p_dat[1] << 8;
    temp |= p_dat[2];

    if (temp >= 8388608) {
        return (-(float)((16777216 - temp) / (float)(0x1 << 13)));
    } else {
        return ((float)(temp / (float)(0x1 << 13)));
    }
}

/**
 * \brief 
 */
void demo_zlg116_tps02r_entry (void)
{
    int ret;
    float temperature;
    uint8_t reg_buf[6];

    am_i2c_device_t i2c_dev;
    am_i2c_handle_t i2c_handle;

    i2c_handle = am_zlg116_i2c1_inst_init();

    am_i2c_mkdev(&i2c_dev,
                 i2c_handle,
                 0x49,       /* ַA0ջVCCʱΪ0x49,GNDΪ0x48 */
                 AM_I2C_ADDR_7BIT | AM_I2C_SUBADDR_1BYTE);

    while (1) {

        am_mdelay(1000);

        ret = am_i2c_read(&i2c_dev,
                          __REG_TEMPERATURE,
                          &reg_buf[0],
                          __REG_TEMPERATURE_LEN);
        if (AM_OK != ret) {

            AM_DBG_INFO("%d:temperature read error:%d!\n", __LINE__, ret);

            continue;
        }

        temperature = __reg_to_temperature(&reg_buf[0]);

        AM_DBG_INFO("ch1 :%f\n", temperature);

        temperature = __reg_to_temperature(&reg_buf[3]);

        AM_DBG_INFO("ch2 :%f\n", temperature);
    }
}

/** [src_zlg116_tps02r] */

/* end of file */
